{% comment %}
Copyright 2017 Mattia Basaglia

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}
{% load simple_page %}
<section>
<header>{% section h2 %}Expense Types{% endsection %}</header>
<form method="post" id='form_expense_types'>
    {% csrf_token %}
    {{ formset.non_field_errors }}
    {{ formset.management_form }}
    <table>
        <thead>
            <tr><th>Name</th><th>Description</th><th>Actions</th></tr>
        </thead>
        {% for form in formset %}
            {% set "row_"|add:form.prefix as parent_id %}
            <tbody id="{{ parent_id }}_wrapper">
                <tr id="{{ parent_id }}">
                    <td>{{ form.name }}{{ form.name.errors }}</td>
                    <td>{{ form.description }}{{ form.description.errors }}</td>
                    <td>{% include "expmon/forms/order.html" with parent_id=parent_id|add:"_wrapper" min_index=1 %}
                        {% include "expmon/forms/delete.html" with toggle_id=parent_id|add:"_undelete" %}
                        {{ form.id }}
                    </td>
                </tr>
                <tr id="{{parent_id}}_undelete">
                    <td colspan="3">Entry deleted {% include "expmon/forms/undelete.html" with toggle_id=parent_id|add:"_undelete" %}</td>
                </tr>
            </tbody>
        {% endfor %}
    </table>
    <button type="button" data-type="add" data-template="formset_template" data-prefix="{{ formset.prefix }}" data-parent="#form_expense_types table">Add</button>
    <button type="submit">Save</button>
</form>
<template id="formset_template">
    {% with formset.empty_form as form %}
        {% set "row_"|add:form.prefix as parent_id %}
        <tbody id="{{ parent_id }}_wrapper">
            <tr id="{{ parent_id }}" >
                <td>{{ form.name }}{{ form.name.errors }}</td>
                <td>{{ form.description }}{{ form.description.errors }}</td>
                <td>{% include "expmon/forms/order.html" with parent_id=parent_id|add:"_wrapper" min_index=1 %}
                    {% include "expmon/forms/delete.html" with toggle_id=parent_id|add:"_undelete" %}
                    {{ form.id }}
                </td>
            </tr>
            <tr id="{{parent_id}}_undelete">
                <td colspan="3">Entry deleted {% include "expmon/forms/undelete.html" with toggle_id=parent_id|add:"_undelete" %}</td>
            </tr>
        </tbody>
    {% endwith %}
</template>
</section>

<script>
    setup_formset('#form_expense_types');
</script>
